﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PingPong
{//www.SourceCodes.ir//

    public partial class Form1 : Form
    {
        double Direction = 0;
        double Angle = 0;
        int Speed = 7;
        int Time = 0;
        bool a = false;

        public Form1()
        {
            InitializeComponent();
        }//www.SourceCodes.ir//

        private void Form1_Load(object sender, EventArgs e)
        {
            ball.Top = panel.Top + (panel.Height / 2) - (ball.Height / 2);
            Random objRnd = new Random();
            
            Direction =objRnd.Next(20,60);
        }//www.SourceCodes.ir//

        private void MoveBall()
        {
            Angle = Math.PI * Direction / 180;
            ball.Top -= (int)(Math.Sin(Angle)*Speed);
            ball.Left += (int)(Math.Cos(Angle)*Speed);
            
                if (ball.Right >= this.Width-10)
                {
                    if (Direction >= 270 && Direction <= 360)
                        Direction = (360 - Direction) + 180;
                    else
                        Direction = 180 - Direction;
                }
                else if (ball.Bottom >= this.Height-10)
                {
                    if (Direction >= 270 && Direction <= 360)
                        Direction = 360 - Direction;
                    else
                        Direction = 90 + (270 - Direction);
                }
                else if (ball.Top <= 10)
                {
                    if (Direction >= 0 && Direction <= 90)
                        Direction = 360 - Direction;
                    else
                        Direction = 180 + (180 - Direction);
                }
                else if (ball.Left <= 0)
                {
                    timer1.Enabled = false;
                    timer2.Enabled = false;
                    MessageBox.Show("Your Time Is:\n\n" + Time.ToString());
                    button1.Visible = true;
                    this.AcceptButton = button1;
                }
                else if (ball.Left <= panel.Right && ball.Top >= panel.Top && ball.Bottom <= panel.Bottom)
                {
                    if (Direction >= 180 && Direction <= 270)
                        Direction = 360 - (Direction - 180);
                    else
                        Direction = 180 - Direction;

                }
            
        }
        //www.SourceCodes.ir//
        private void timer1_Tick(object sender, EventArgs e)
        {
            MoveBall();
        }
        //www.SourceCodes.ir//
        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.Up:
                    panel.Top -= 10;
                    if (timer1.Enabled == false)
                    {
                        ball.Top -= 30;
                    }
                    break;
                case Keys.Down:
                    panel.Top += 10;
                    if (timer1.Enabled == false)
                    {
                        ball.Top += 30;
                    }
                    break;
                case Keys.Space:
                    timer1.Enabled = true;
                    timer2.Enabled = true;
                    break;
            }
        }
        //www.SourceCodes.ir//
        private void timer2_Tick(object sender, EventArgs e)
        {
            Time++;
            if (Time == 20)
                Speed += 5;
            else if (Time == 40)
                Speed += 5;
            else if (Time == 60)
                Speed += 10;
            label1.Text = "Your Time: " + Time.ToString();
        }
        //www.SourceCodes.ir//
        private void button1_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
    }//www.SourceCodes.ir////www.SourceCodes.ir////www.SourceCodes.ir//
}
